//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "expert.cpp"
#include "about.cpp"
#include "case.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfmMain *fmMain;
//---------------------------------------------------------------------------
complex operator *(complex z1,complex z2)
{
 complex z;
 z.x=z1.x*z2.x-z1.y*z2.y;
 z.y=z1.x*z2.y+z1.y*z2.x;
 return z;
}
//---------------------------------------------------------------------------
complex operator +(complex z1, complex z2)
{
 complex z;
 z.x=z1.x+z2.x;
 z.y=z1.y+z2.y;
 return z;
}
//---------------------------------------------------------------------------
double operator !(complex z)
/*     */
{
 return (z.x*z.x+z.y*z.y);
}
//---------------------------------------------------------------------------
__fastcall TfmMain::TfmMain(TComponent* Owner)
   : TForm(Owner)
{
 a.x=1.8;
 a.y=0;
 b.x=0;
 b.y=0.2;
 curpal=0;
 r2=4;
 width=imgImage->Width;
 height=imgImage->Height;
 alpha=1;
 beta=0.75;
 x0=0;
 y0=0;
 Koef=.7;
 numpal=10;
 outputwidth=800;
 outputheight=600;
}
//---------------------------------------------------------------------------
int TfmMain::julia(complex z, complex a, complex b)
{
 complex t;
 int i;
 t=z;
 for(i=0; i<MAX_ITER; i++)
 {
  t=a*(t*t+b);
  if((!t)>r2) return(i);              //    
 }
 return(MAX_ITER);
}
//---------------------------------------------------------------------------
void TfmMain::generate_image(char *fname, int width, int height,
                             int curpal, double x0, double y0,
                             double alpha, double beta,
                             complex a, complex b, int fl)/*   */
{
 int i, j;
 int f; /* - */
 int n;
 char buf; /*   */
 complex z;

 char BMPhead[]={0x42, 0x4D, 0xff, 0xff,
                 0xff, 0xff, 0x00, 0x00,
                 0x00, 0x00, 0x36, 0x00,
                 0x00, 0x00, 0x28, 0x00,
                 0x00, 0x00, 0x00, 0x04,
                 0x00, 0x00, 0x00, 0x03,
                 0x00, 0x00, 0x01, 0x00,
                 0x18, 0x00, 0x00, 0x00,
                 0x00, 0x00, 0x00, 0xff,
                 0xff, 0x00, 0x00, 0x00,
                 0x00, 0x00, 0x00, 0x00,
                 0x00, 0x00, 0x00, 0x00,
                 0x00, 0x00, 0x00, 0x00,
                 0x00, 0x00};
 /*      */
 *(((DWORD*)(BMPhead+2))+4)=width;
 *(((DWORD*)(BMPhead+2))+5)=height;

 f=open(fname, O_CREAT|O_TRUNC|O_BINARY|O_WRONLY, S_IREAD|S_IWRITE);
 if(f==-1)
 {
  MessageBox(NULL, "   .", "", MB_ICONWARNING|MB_TASKMODAL);
  return;
 }
 write(f, BMPhead, 54);
 for(j=0; j<height; j++)
 {
  for(i=0; i<width; i++) /*    */
  {
   z.x=alpha*(2*(i/(double)width)-1+x0);
   z.y=beta*(2*(j/(double)height)-1+y0);
   n=julia(z, a, b); /*  ? */
   buf=(char)blue(n<255?n:255, curpal);
   write(f, &buf, 1); /*    */
   buf=(char)green(n<255?n:255, curpal);
   write(f, &buf, 1); /*    */
   buf=(char)red(n<255?n:255, curpal);
   write(f, &buf, 1); /*    */
  }
  if(fl)Application->ProcessMessages();
  buf=0;
  for(i=0; i<width%4; i++)write(f, &buf, 1); /*    4-  */
 }
 close(f);
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::imgImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 double w=(double)imgImage->Width;
 double h=(double)imgImage->Height;
 x0+=2*(double)X/w-1;
 y0+=2*(h-(double)Y)/h-1;

 if(Button==mbRight)
 {
  if(Shift.Contains(ssAlt))
  {
   alpha/=Koef;
   beta/=Koef;
   x0*=Koef;
   y0*=Koef;
  }
  else
  {
   alpha*=Koef;
   beta*=Koef;
   x0/=Koef;
   y0/=Koef;
  }
 }
 update();
}
//---------------------------------------------------------------------------
void TfmMain::update(void)
/*     ( 0,   ) */
{
 generate_image("Temporary.bmp", width, height, curpal, x0, y0, alpha, beta, a, b, 0);
 imgImage->Picture->LoadFromFile("Temporary.bmp");
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::FormCreate(TObject *Sender)
{
 randomize();
 update();
}
//---------------------------------------------------------------------------
//--------------------------------
/*      ""  */
int TfmMain::red(int i, int curpal)
{
 switch(curpal)
 {
  case 0: return(255*exp(-fabs((i-50)*0.0086)));  /* */
  case 1: return(255-8*fabs(0.1*(i-60)));        /*  */
  case 2: return(1.2*(64-2*fabs(0.1*(i-40))));  /* */
  case 3: return(127+128*sin((3.14*i)/256));   /*  */
  case 4: return(128+i/2);                    /*   */
  case 5: return(128+i/2);                   /*      */
  case 6: return(0);                        /*=*/
  case 7: return i;                        /* */
  case 8: return i;                       /**/
  default: return(i);                    /*   */
 }
}

int TfmMain::green(int i, int curpal)
{
 switch(curpal)
 {
  case 0: return(255*exp(-fabs((i-130)*0.0086)));
  case 1: return(255-8*fabs(0.1*(i-60)));
  case 2: return(1.2*(64-2*fabs(0.1*(i-130))));
  case 3: return(127+128*sin((3.14*i+6.28/3)/256));
  case 4: return(128+i/2);
  case 5: return(128+i/2);
  case 6: return(((i-127)*(i-127))/64);
  case 7: return 0;
  case 8: return i<200?0:((double)(i-200))*255/55;
  default: return(i);
 }
}

int TfmMain::blue(int i, int curpal)
{
 switch(curpal)
 {
  case 0: return(255*exp(-fabs((i-200)*0.0086)));
  case 1: return(1.2*(64-2*fabs(0.1*(i-200))));
  case 2: return(256-8*fabs(0.1*(i-230)));
  case 3: return(128+i/2);
  case 4: return(128+i/2);
  case 5: return((128+i)%256);
  case 6: return(0);
  case 7: return 0;
  case 8: return 0;
  default: return(i);
 }
}
void __fastcall TfmMain::N1Click(TObject *Sender)
{
 ((TMenuItem*)Sender)->Checked=True; /*   */
  curpal=((TMenuItem*)Sender)->Tag; /*    */
  update();
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::R1Click(TObject *Sender)
{
 ((TMenuItem*)Sender)->Checked=True; /*   */
 outputwidth=((TMenuItem*)Sender)->Tag; /*    */
 outputheight=outputwidth*0.75;        /*    */
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::btPlusClick(TObject *Sender)
/*   */
{
 alpha*=Koef;
 beta*=Koef;
 x0/=Koef;
 y0/=Koef;
 update();
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::btMinusClick(TObject *Sender)
/*   */
{
 alpha/=Koef;
 beta/=Koef;
 x0*=Koef;
 y0*=Koef;
 update();
}
//---------------------------------------------------------------------------


void __fastcall TfmMain::btSaveClick(TObject *Sender)
/*        */
{
 TForm *fmTmp;
 TImage *imgTmp;
 TLabel *lbTmp;
 AnsiString FileName;
 int outputw=outputwidth, outputh=outputheight; /*   */
 if(diagSave->Execute()) /*  ,   */
 {
  FileName=diagSave->FileName;
  fmTmp=new TForm((TComponent *)0);
  fmTmp->BorderStyle=bsToolWindow; /*      */
  imgTmp=new TImage(fmTmp);
  lbTmp=new TLabel(fmTmp); /*  ,     */
  lbTmp->Parent=fmTmp;
  lbTmp->AutoSize=1;
  lbTmp->Caption=" .";
  fmTmp->ClientWidth=lbTmp->Width;
  fmTmp->ClientHeight=lbTmp->Height;
  fmTmp->Position=poScreenCenter;
  fmTmp->Caption="";
  fmTmp->Show();
  generate_image(FileName.c_str(), outputw, outputh, curpal, x0, y0, alpha, beta, a, b, 1); /*   */
  fmTmp->Caption=FileName;
  fmTmp->ClientWidth=outputw; /*   */
  fmTmp->ClientHeight=outputh;
  fmTmp->AutoScroll=1;
  imgTmp->Width=outputw;
  imgTmp->Height=outputh;
  imgTmp->Picture->LoadFromFile(FileName); /*   */
  imgTmp->Parent=fmTmp;
  delete lbTmp; /*     */
  fmTmp->Left=0;
  fmTmp->Top=0;
  fmTmp->Show();
 }
 update();
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::miSaveClick(TObject *Sender)
{
 btSave->Click();
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::miNewClick(TObject *Sender)
{
 btNew->Click();
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::FormKeyPress(TObject *Sender, char &Key)
{
 switch (Key)
 {
  case '*': btPalPlus->Click();  break;
  case '/': btPalMinus->Click(); break;
  case '+': btPlus->Click(); break;
  case '-': btMinus->Click();  break;
 }
}
//---------------------------------------------------------------------------
void TfmMain::CheckCurrentPallete(void)
/*      */
{
 int i;
 TMenuItem *cur;
 cur=mmMain->Items->Items[1]->Items[0]; /*   "->" */
 for(i=0; i<cur->Count; i++) /*   */
 {
  if(cur->Items[i]->Tag==curpal) cur->Items[i]->Checked=1; /* !    */
 }
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::btPalMinusClick(TObject *Sender)
{
 if(!curpal) curpal=numpal-1;
 else curpal=(curpal-1)%numpal;
 update();
 CheckCurrentPallete();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::btPalPlusClick(TObject *Sender)
{
 curpal=(curpal+1)%numpal;
 update();
 CheckCurrentPallete();
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::btNewClick(TObject *Sender)
{
 newfract(random(MAXNEW));
 beta=0.75*alpha;
 update();
 CheckCurrentPallete();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::miExpertClick(TObject *Sender)
{
 /*      */
 fmExpert->edAx->Text=a.x;
 fmExpert->edAy->Text=a.y;
 fmExpert->edBx->Text=b.x;
 fmExpert->edBy->Text=b.y;
 fmExpert->edWid->Text=outputwidth;
 fmExpert->edHei->Text=outputheight;
 /*       */
 fmExpert->edAx->Text=ChangePoint(fmExpert->edAx->Text);
 fmExpert->edAy->Text=ChangePoint(fmExpert->edAy->Text);
 fmExpert->edBx->Text=ChangePoint(fmExpert->edBx->Text);
 fmExpert->edBy->Text=ChangePoint(fmExpert->edBy->Text);
 fmExpert->ShowModal();
 /*  ,    */
 a.x=atof(fmExpert->edAx->Text.c_str());
 a.y=atof(fmExpert->edAy->Text.c_str());
 b.x=atof(fmExpert->edBx->Text.c_str());
 b.y=atof(fmExpert->edBy->Text.c_str());
 outputwidth=atoi(fmExpert->edWid->Text.c_str());
 if(outputwidth<1) outputwidth=1;
 outputheight=atoi(fmExpert->edHei->Text.c_str());
 if(outputheight<1) outputheight=1;
 update();
}
//---------------------------------------------------------------------------
AnsiString TfmMain::ChangePoint(AnsiString s)
/*     */
{
 int i;
 for(i=0; i<s.Length(); i++)
 {
  if(s[i+1]==',') s[i+1]='.';
 }
 return(s);
}
//---------------------------------------------------------------------------
void __fastcall TfmMain::miAboutClick(TObject *Sender)
{
 fmAbout->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::miManualClick(TObject *Sender)
{
// Application->HelpFile="julia.hlp";
 Application->HelpCommand(HELP_CONTENTS, 0);
}
//---------------------------------------------------------------------------

