//---------------------------------------------------------------------------
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <io.h>
#include <fcntl.h>
#include <math.h>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <sys\stat.h>
#include "stdlib.h"
#include "stdio.h"
//---------------------------------------------------------------------------
#define MAX_ITER 256 /*    */
#define MAXNEW 111 /*  ""  */
//---------------------------------------------------------------------------
struct complex /*  " " */
{
 double x;
 double y;
};
//---------------------------------------------------------------------------
complex operator *(complex z1,complex z2);  // |    
complex operator +(complex z1, complex z2); // |     
double operator !(complex z);                // |  
//---------------------------------------------------------------------------

class TfmMain : public TForm
{
__published:    // IDE-managed Components
   TImage *imgImage;
   TButton *btMinus;
   TButton *btPlus;
   TButton *btNew;
   TButton *btSave;
   TMainMenu *mmMain;
   TMenuItem *miFile;
   TMenuItem *miSave;
   TMenuItem *miExit;
   TMenuItem *miNew;
   TMenuItem *miOption;
   TMenuItem *miPalette;
   TMenuItem *miResolution;
   TMenuItem *miExpert;
   TMenuItem *miHelp;
   TMenuItem *miManual;
   TMenuItem *miAbout;
   TMenuItem *N1;
   TMenuItem *N2;
   TMenuItem *N3;
   TMenuItem *N4;
   TMenuItem *N5;
   TMenuItem *N6;
   TMenuItem *N7;
   TMenuItem *N8;
   TMenuItem *N9;
   TMenuItem *N10;
   TMenuItem *R1;
   TMenuItem *R2;
   TMenuItem *R3;
   TMenuItem *R4;
   TSaveDialog *diagSave;
   TButton *btPalMinus;
   TButton *btPalPlus;
   void __fastcall imgImageMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
   void __fastcall FormCreate(TObject *Sender);
   void __fastcall N1Click(TObject *Sender);
   void __fastcall R1Click(TObject *Sender);
   void __fastcall btPlusClick(TObject *Sender);
   void __fastcall btMinusClick(TObject *Sender);
   void __fastcall btSaveClick(TObject *Sender);
   void __fastcall miSaveClick(TObject *Sender);
   void __fastcall miNewClick(TObject *Sender);
   void __fastcall FormKeyPress(TObject *Sender, char &Key);
   void __fastcall btPalMinusClick(TObject *Sender);
   void __fastcall btPalPlusClick(TObject *Sender);
   void __fastcall btNewClick(TObject *Sender);
   void __fastcall miExpertClick(TObject *Sender);
   void __fastcall miAboutClick(TObject *Sender);
   void __fastcall miManualClick(TObject *Sender);
private:        // User declarations
 complex a; /*  */
 complex b;
 int curpal;           //  
 double r2;
 int width; /*   */
 int height;/*   */
 double alpha; /*  */
 double beta;
 double x0;    /*  */
 double y0;
 double Koef; /*   */
 int numpal; /*   */
 int outputwidth;  /*      */
 int outputheight;

 int julia(complex z, complex alpha, complex beta); /*      <x,y> */
 void generate_image(char*fname, int width, int height,
                     int curpal, double x0, double y0,
                     double alpha, double beta,
                     complex a, complex b, int fl); /*   */
 /*:*/
 int red(int i, int curpal);
 int green(int i, int curpal);
 int blue(int i, int curpal);
 void update(void);/*     */
 void CheckCurrentPallete(void); /*      */
 AnsiString ChangePoint(AnsiString s); /*     */
 void newfract(int i); /*     */
public:         // User declarations
   __fastcall TfmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmMain *fmMain;
//---------------------------------------------------------------------------
#endif
